diff --git a/tests/intel-ci/README b/tests/intel-ci/README
new file mode 100644
index 0000000..dc7e5c8
--- /dev/null
+++ b/tests/intel-ci/README
@@ -0,0 +1,34 @@
+This directory contains test lists that are used by Intel's CI. The
+files are passed to piglit with the --test-list parameter directly.
+
+The test lists are contained in the IGT repository for several
+reasons:
+
+- The lists stay synchronized with the IGT codebase.
+- Public availability. Kernel developers can see what tests are run,
+  and can see what changes are done to the set, when, and why.
+- Explicit test lists in general make it possible to implement a new
+  test without having it run in CI (accidentally or on purpose) before
+  CI is ready for it, and for CI to stop running a test without
+  removing the test or changing its name. The previous method of test
+  selection was based on name patterns.
+
+Changing the test lists should only happen with approval from the CI
+people. If you make a new test that should be tested by CI regularly,
+ask a maintainer (see MAINTAINERS).
+
+======================
+fast-feedback.testlist
+======================
+
+Fast-feedback is the testlist that is run for Patchwork and Trybot
+testing. It is also run on various drm-intel-* branches.
+
+Time limit: Full run must complete in 15 minutes on all tested
+platforms.
+
+Feature coverage: Should test all working features, with at least 1
+test per feature.
+
+The string "basic" in a test name means the test probably belongs in
+this list.
diff --git a/tests/intel-ci/fast-feedback.testlist b/tests/intel-ci/fast-feedback.testlist
new file mode 100644
index 0000000..6f9349c
--- /dev/null
+++ b/tests/intel-ci/fast-feedback.testlist
@@ -0,0 +1,611 @@
+igt@core_auth@basic-auth
+igt@core_auth@many-magics
+igt@core_getclient
+igt@core_get_client_auth@master-drop
+igt@core_get_client_auth@simple
+igt@core_getstats
+igt@core_getversion
+igt@core_prop_blob@basic
+igt@core_prop_blob@blob-multiple
+igt@core_prop_blob@blob-prop-core
+igt@core_prop_blob@blob-prop-lifetime
+igt@core_prop_blob@blob-prop-validate
+igt@core_prop_blob@invalid-get-prop
+igt@core_prop_blob@invalid-get-prop-any
+igt@core_prop_blob@invalid-set-prop
+igt@core_prop_blob@invalid-set-prop-any
+igt@core_setmaster_vs_auth
+igt@debugfs_emon_crash
+igt@drm_import_export@import-close-race-flink
+igt@drm_import_export@import-close-race-prime
+igt@drm_read@empty-nonblock
+igt@drm_read@fault-buffer
+igt@drm_read@invalid-buffer
+igt@drm_read@short-buffer-block
+igt@drm_read@short-buffer-nonblock
+igt@drm_vma_limiter
+igt@drm_vma_limiter_cpu
+igt@drv_debugfs_reader
+igt@drv_getparams_basic@basic-eu-total
+igt@drv_getparams_basic@basic-subslice-total
+igt@drv_hangman@error-state-basic
+igt@drv_hangman@error-state-debugfs-entry
+igt@drv_hangman@error-state-sysfs-entry
+igt@drv_module_reload_basic
+igt@gem_bad_length
+igt@gem_bad_reloc@negative-reloc-blt
+igt@gem_bad_reloc@negative-reloc-bltcopy
+igt@gem_bad_reloc@negative-reloc-bsd
+igt@gem_bad_reloc@negative-reloc-bsd1
+igt@gem_bad_reloc@negative-reloc-bsd2
+igt@gem_bad_reloc@negative-reloc-default
+igt@gem_bad_reloc@negative-reloc-lut-blt
+igt@gem_bad_reloc@negative-reloc-lut-bsd
+igt@gem_bad_reloc@negative-reloc-lut-bsd1
+igt@gem_bad_reloc@negative-reloc-lut-bsd2
+igt@gem_bad_reloc@negative-reloc-lut-default
+igt@gem_bad_reloc@negative-reloc-lut-render
+igt@gem_bad_reloc@negative-reloc-lut-vebox
+igt@gem_bad_reloc@negative-reloc-render
+igt@gem_bad_reloc@negative-reloc-vebox
+igt@gem_basic@bad-close
+igt@gem_basic@create-close
+igt@gem_basic@create-fd-close
+igt@gem_busy@basic-busy-default
+igt@gem_busy@basic-hang-default
+igt@gem_caching@reads
+igt@gem_close_race@basic-process
+igt@gem_close_race@basic-threads
+igt@gem_close_race@process-exit
+igt@gem_cpu_reloc@basic
+igt@gem_create@create-invalid-nonaligned
+igt@gem_create@create-invalid-size
+igt@gem_create@create-valid-nonaligned
+igt@gem_cs_tlb@basic-default
+igt@gem_cs_tlb@blt
+igt@gem_cs_tlb@bsd
+igt@gem_cs_tlb@bsd1
+igt@gem_cs_tlb@bsd2
+igt@gem_cs_tlb@render
+igt@gem_cs_tlb@vebox
+igt@gem_ctx_bad_destroy@double-destroy
+igt@gem_ctx_bad_destroy@invalid-ctx
+igt@gem_ctx_bad_destroy@invalid-default-ctx
+igt@gem_ctx_bad_destroy@invalid-pad
+igt@gem_ctx_bad_exec@blt
+igt@gem_ctx_bad_exec@bsd
+igt@gem_ctx_bad_exec@render
+igt@gem_ctx_bad_exec@vebox
+igt@gem_ctx_basic
+igt@gem_ctx_create@basic
+igt@gem_ctx_create@basic-files
+igt@gem_ctx_create@invalid-pad
+igt@gem_ctx_exec@basic
+igt@gem_ctx_exec@lrc-lite-restore
+igt@gem_ctx_param@basic
+igt@gem_ctx_param@basic-default
+igt@gem_ctx_param@invalid-ctx-get
+igt@gem_ctx_param@invalid-ctx-set
+igt@gem_ctx_param@invalid-size-get
+igt@gem_ctx_param@invalid-size-set
+igt@gem_ctx_param@non-root-set
+igt@gem_ctx_param@non-root-set-no-zeromap
+igt@gem_ctx_param@root-set
+igt@gem_ctx_param@root-set-no-zeromap-disabled
+igt@gem_ctx_param@root-set-no-zeromap-enabled
+igt@gem_ctx_switch@basic-default
+igt@gem_ctx_switch@basic-default-heavy
+igt@gem_exec_bad_domains@conflicting-write-domain
+igt@gem_exec_bad_domains@cpu-domain
+igt@gem_exec_bad_domains@double-write-domain
+igt@gem_exec_bad_domains@gtt-domain
+igt@gem_exec_bad_domains@invalid-gpu-domain
+igt@gem_exec_basic@basic-blt
+igt@gem_exec_basic@basic-bsd
+igt@gem_exec_basic@basic-bsd1
+igt@gem_exec_basic@basic-bsd2
+igt@gem_exec_basic@basic-default
+igt@gem_exec_basic@basic-render
+igt@gem_exec_basic@basic-vebox
+igt@gem_exec_basic@gtt-blt
+igt@gem_exec_basic@gtt-bsd
+igt@gem_exec_basic@gtt-bsd1
+igt@gem_exec_basic@gtt-bsd2
+igt@gem_exec_basic@gtt-default
+igt@gem_exec_basic@gtt-render
+igt@gem_exec_basic@gtt-vebox
+igt@gem_exec_basic@readonly-blt
+igt@gem_exec_basic@readonly-bsd
+igt@gem_exec_basic@readonly-bsd1
+igt@gem_exec_basic@readonly-bsd2
+igt@gem_exec_basic@readonly-default
+igt@gem_exec_basic@readonly-render
+igt@gem_exec_basic@readonly-vebox
+igt@gem_exec_blt@cold
+igt@gem_exec_blt@cold-max
+igt@gem_exec_blt@cold-min
+igt@gem_exec_blt@dumb-buf
+igt@gem_exec_blt@dumb-buf-max
+igt@gem_exec_blt@dumb-buf-min
+igt@gem_exec_blt@normal
+igt@gem_exec_blt@normal-max
+igt@gem_exec_blt@normal-min
+igt@gem_exec_create@basic
+igt@gem_exec_faulting_reloc@no-prefault
+igt@gem_exec_faulting_reloc@normal
+igt@gem_exec_flush@basic-batch-kernel-default-cmd
+igt@gem_exec_flush@basic-batch-kernel-default-uc
+igt@gem_exec_flush@basic-batch-kernel-default-wb
+igt@gem_exec_flush@basic-uc-pro-default
+igt@gem_exec_flush@basic-uc-prw-default
+igt@gem_exec_flush@basic-uc-ro-default
+igt@gem_exec_flush@basic-uc-rw-default
+igt@gem_exec_flush@basic-uc-set-default
+igt@gem_exec_flush@basic-wb-pro-default
+igt@gem_exec_flush@basic-wb-prw-default
+igt@gem_exec_flush@basic-wb-ro-before-default
+igt@gem_exec_flush@basic-wb-ro-default
+igt@gem_exec_flush@basic-wb-rw-before-default
+igt@gem_exec_flush@basic-wb-rw-default
+igt@gem_exec_flush@basic-wb-set-default
+igt@gem_exec_gttfill@basic
+igt@gem_exec_nop@basic-parallel
+igt@gem_exec_nop@basic-series
+igt@gem_exec_parallel@basic
+igt@gem_exec_parallel@blt
+igt@gem_exec_parallel@bsd
+igt@gem_exec_parallel@bsd1
+igt@gem_exec_parallel@bsd2
+igt@gem_exec_parallel@default
+igt@gem_exec_parallel@render
+igt@gem_exec_parallel@vebox
+igt@gem_exec_params@cliprects-invalid
+igt@gem_exec_params@cliprects_ptr-dirt
+igt@gem_exec_params@control
+igt@gem_exec_params@dr1-dirt
+igt@gem_exec_params@dr4-dirt
+igt@gem_exec_params@invalid-bsd1-flag-on-blt
+igt@gem_exec_params@invalid-bsd1-flag-on-render
+igt@gem_exec_params@invalid-bsd1-flag-on-vebox
+igt@gem_exec_params@invalid-bsd2-flag-on-blt
+igt@gem_exec_params@invalid-bsd2-flag-on-render
+igt@gem_exec_params@invalid-bsd2-flag-on-vebox
+igt@gem_exec_params@invalid-bsd-ring
+igt@gem_exec_params@invalid-flag
+igt@gem_exec_params@invalid-ring
+igt@gem_exec_params@invalid-ring2
+igt@gem_exec_params@rel-constants-invalid
+igt@gem_exec_params@rel-constants-invalid-rel-gen5
+igt@gem_exec_params@rel-constants-invalid-ring
+igt@gem_exec_params@rs-invalid-on-blt-ring
+igt@gem_exec_params@rs-invalid-on-bsd-ring
+igt@gem_exec_params@rs-invalid-on-vebox-ring
+igt@gem_exec_params@rsvd2-dirt
+igt@gem_exec_params@secure-non-master
+igt@gem_exec_params@secure-non-root
+igt@gem_exec_params@sol-reset-invalid
+igt@gem_exec_params@sol-reset-not-gen7
+igt@gem_exec_parse@basic-allowed
+igt@gem_exec_parse@basic-rejected
+igt@gem_exec_reloc@active
+igt@gem_exec_reloc@active-blt
+igt@gem_exec_reloc@active-bsd
+igt@gem_exec_reloc@active-bsd1
+igt@gem_exec_reloc@active-bsd2
+igt@gem_exec_reloc@active-default
+igt@gem_exec_reloc@active-render
+igt@gem_exec_reloc@active-vebox
+igt@gem_exec_reloc@cpu-12
+igt@gem_exec_reloc@cpu-13
+igt@gem_exec_reloc@cpu-14
+igt@gem_exec_reloc@cpu-15
+igt@gem_exec_reloc@cpu-16
+igt@gem_exec_reloc@cpu-17
+igt@gem_exec_reloc@cpu-18
+igt@gem_exec_reloc@cpu-19
+igt@gem_exec_reloc@cpu-20
+igt@gem_exec_reloc@cpu-21
+igt@gem_exec_reloc@cpu-22
+igt@gem_exec_reloc@cpu-23
+igt@gem_exec_reloc@cpu-24
+igt@gem_exec_reloc@cpu-25
+igt@gem_exec_reloc@cpu-26
+igt@gem_exec_reloc@cpu-27
+igt@gem_exec_reloc@cpu-28
+igt@gem_exec_reloc@gpu
+igt@gem_exec_reloc@gtt-12
+igt@gem_exec_reloc@gtt-13
+igt@gem_exec_reloc@gtt-14
+igt@gem_exec_reloc@gtt-15
+igt@gem_exec_reloc@gtt-16
+igt@gem_exec_reloc@gtt-17
+igt@gem_exec_reloc@gtt-18
+igt@gem_exec_reloc@gtt-19
+igt@gem_exec_reloc@gtt-20
+igt@gem_exec_reloc@gtt-21
+igt@gem_exec_reloc@gtt-22
+igt@gem_exec_reloc@gtt-23
+igt@gem_exec_reloc@gtt-24
+igt@gem_exec_reloc@gtt-25
+igt@gem_exec_reloc@gtt-26
+igt@gem_exec_reloc@mmap-12
+igt@gem_exec_reloc@mmap-13
+igt@gem_exec_reloc@mmap-14
+igt@gem_exec_reloc@mmap-15
+igt@gem_exec_reloc@mmap-16
+igt@gem_exec_reloc@mmap-17
+igt@gem_exec_reloc@mmap-18
+igt@gem_exec_reloc@mmap-19
+igt@gem_exec_reloc@mmap-20
+igt@gem_exec_reloc@mmap-21
+igt@gem_exec_reloc@mmap-22
+igt@gem_exec_reloc@mmap-23
+igt@gem_exec_reloc@mmap-24
+igt@gem_exec_reloc@mmap-25
+igt@gem_exec_reloc@mmap-26
+igt@gem_exec_reloc@mmap-27
+igt@gem_exec_reloc@mmap-28
+igt@gem_exec_reloc@mmap-29
+igt@gem_exec_reloc@wc-12
+igt@gem_exec_reloc@wc-13
+igt@gem_exec_reloc@wc-14
+igt@gem_exec_reloc@wc-15
+igt@gem_exec_reloc@wc-16
+igt@gem_exec_reloc@wc-17
+igt@gem_exec_reloc@wc-18
+igt@gem_exec_reloc@wc-19
+igt@gem_exec_reloc@wc-20
+igt@gem_exec_reloc@wc-21
+igt@gem_exec_reloc@wc-22
+igt@gem_exec_reloc@wc-23
+igt@gem_exec_reloc@wc-24
+igt@gem_exec_reloc@wc-25
+igt@gem_exec_reloc@wc-26
+igt@gem_exec_reloc@wc-27
+igt@gem_exec_store@basic-all
+igt@gem_exec_store@basic-blt
+igt@gem_exec_store@basic-bsd
+igt@gem_exec_store@basic-bsd1
+igt@gem_exec_store@basic-bsd2
+igt@gem_exec_store@basic-default
+igt@gem_exec_store@basic-render
+igt@gem_exec_store@basic-vebox
+igt@gem_exec_suspend@basic
+igt@gem_exec_suspend@basic-s3
+igt@gem_exec_suspend@basic-s4
+igt@gem_exec_suspend@blt-cached
+igt@gem_exec_suspend@blt-uncached
+igt@gem_exec_suspend@bsd1-cached
+igt@gem_exec_suspend@bsd1-uncached
+igt@gem_exec_suspend@bsd2-cached
+igt@gem_exec_suspend@bsd2-uncached
+igt@gem_exec_suspend@bsd-cached
+igt@gem_exec_suspend@bsd-uncached
+igt@gem_exec_suspend@default-cached
+igt@gem_exec_suspend@default-uncached
+igt@gem_exec_suspend@render-cached
+igt@gem_exec_suspend@render-uncached
+igt@gem_exec_suspend@vebox-cached
+igt@gem_exec_suspend@vebox-uncached
+igt@gem_fenced_exec_thrash@2-spare-fences
+igt@gem_fenced_exec_thrash@no-spare-fences
+igt@gem_fenced_exec_thrash@no-spare-fences-busy
+igt@gem_fenced_exec_thrash@no-spare-fences-busy-interruptible
+igt@gem_fenced_exec_thrash@no-spare-fences-interruptible
+igt@gem_fenced_exec_thrash@too-many-fences
+igt@gem_flink_basic@bad-flink
+igt@gem_flink_basic@bad-open
+igt@gem_flink_basic@basic
+igt@gem_flink_basic@double-flink
+igt@gem_flink_basic@flink-lifetime
+igt@gem_gpgpu_fill
+igt@gem_gtt_cpu_tlb
+igt@gem_largeobject
+igt@gem_linear_blits@basic
+igt@gem_madvise@dontneed-after-mmap
+igt@gem_madvise@dontneed-before-exec
+igt@gem_madvise@dontneed-before-mmap
+igt@gem_madvise@dontneed-before-pwrite
+igt@gem_media_fill
+igt@gem_mmap@bad-object
+igt@gem_mmap@basic
+igt@gem_mmap@basic-small-bo
+igt@gem_mmap@big-bo
+igt@gem_mmap_gtt@basic
+igt@gem_mmap_gtt@basic-copy
+igt@gem_mmap_gtt@basic-read
+igt@gem_mmap_gtt@basic-read-no-prefault
+igt@gem_mmap_gtt@basic-read-write
+igt@gem_mmap_gtt@basic-read-write-distinct
+igt@gem_mmap_gtt@basic-short
+igt@gem_mmap_gtt@basic-small-bo
+igt@gem_mmap_gtt@basic-small-bo-tiledx
+igt@gem_mmap_gtt@basic-small-bo-tiledy
+igt@gem_mmap_gtt@basic-small-copy
+igt@gem_mmap_gtt@basic-small-copy-xy
+igt@gem_mmap_gtt@basic-wc
+igt@gem_mmap_gtt@basic-write
+igt@gem_mmap_gtt@basic-write-cpu-read-gtt
+igt@gem_mmap_gtt@basic-write-gtt
+igt@gem_mmap_gtt@basic-write-gtt-no-prefault
+igt@gem_mmap_gtt@basic-write-no-prefault
+igt@gem_mmap_gtt@basic-write-read
+igt@gem_mmap_gtt@basic-write-read-distinct
+igt@gem_mmap_gtt@big-bo
+igt@gem_mmap_gtt@coherency
+igt@gem_mmap_gtt@fault-concurrent
+igt@gem_mmap@short-mmap
+igt@gem_mmap_wc@close
+igt@gem_mmap_wc@coherency
+igt@gem_mmap_wc@copy
+igt@gem_mmap_wc@fault-concurrent
+igt@gem_mmap_wc@invalid-flags
+igt@gem_mmap_wc@read
+igt@gem_mmap_wc@read-no-prefault
+igt@gem_mmap_wc@read-write
+igt@gem_mmap_wc@read-write-distinct
+igt@gem_mmap_wc@set-cache-level
+igt@gem_mmap_wc@write
+igt@gem_mmap_wc@write-cpu-read-wc
+igt@gem_mmap_wc@write-cpu-read-wc-unflushed
+igt@gem_mmap_wc@write-gtt
+igt@gem_mmap_wc@write-gtt-no-prefault
+igt@gem_mmap_wc@write-gtt-read-wc
+igt@gem_mmap_wc@write-no-prefault
+igt@gem_mmap_wc@write-read
+igt@gem_mmap_wc@write-read-distinct
+igt@gem_mocs_settings@mocs-rc6
+igt@gem_mocs_settings@mocs-reset
+igt@gem_mocs_settings@mocs-settings
+igt@gem_partial_pwrite_pread@reads
+igt@gem_partial_pwrite_pread@reads-display
+igt@gem_partial_pwrite_pread@reads-snoop
+igt@gem_partial_pwrite_pread@reads-uncached
+igt@gem_ppgtt@flink-and-close-vma-leak
+igt@gem_ppgtt@flink-and-exit-vma-leak
+igt@gem_pread_after_blit@default-interruptible
+igt@gem_pread_after_blit@default-normal
+igt@gem_pread_after_blit@display-interruptible
+igt@gem_pread_after_blit@display-normal
+igt@gem_pread_after_blit@snooped-interruptible
+igt@gem_pread_after_blit@snooped-normal
+igt@gem_pread_after_blit@uncached-interruptible
+igt@gem_pread_after_blit@uncached-normal
+igt@gem_pread@basic
+igt@gem_pread@display
+igt@gem_pread@snoop
+igt@gem_pread@uncached
+igt@gem_pwrite@basic
+igt@gem_pwrite@display
+igt@gem_pwrite_pread@display-copy-correctness
+igt@gem_pwrite_pread@display-pwrite-blt-gtt_mmap-correctness
+igt@gem_pwrite_pread@snooped-copy-correctness
+igt@gem_pwrite_pread@snooped-pwrite-blt-cpu_mmap-correctness
+igt@gem_pwrite_pread@uncached-copy-correctness
+igt@gem_pwrite_pread@uncached-pwrite-blt-gtt_mmap-correctness
+igt@gem_pwrite@snoop
+igt@gem_pwrite_snooped
+igt@gem_read_read_speed@read-read-128x128
+igt@gem_read_read_speed@read-read-1x1
+igt@gem_read_read_speed@read-read-256x256
+igt@gem_read_read_speed@read-read-512x512
+igt@gem_read_read_speed@read-write-128x128
+igt@gem_read_read_speed@read-write-1x1
+igt@gem_read_read_speed@read-write-256x256
+igt@gem_read_read_speed@read-write-512x512
+igt@gem_read_read_speed@write-read-128x128
+igt@gem_read_read_speed@write-read-1x1
+igt@gem_read_read_speed@write-read-256x256
+igt@gem_read_read_speed@write-read-512x512
+igt@gem_read_read_speed@write-write-128x128
+igt@gem_read_read_speed@write-write-1x1
+igt@gem_read_read_speed@write-write-256x256
+igt@gem_read_read_speed@write-write-512x512
+igt@gem_readwrite@beyond-eob
+igt@gem_readwrite@new-obj
+igt@gem_readwrite@read-bad-handle
+igt@gem_readwrite@read-write
+igt@gem_readwrite@write-bad-handle
+igt@gem_reg_read@bad-register
+igt@gem_reloc_overflow@batch-both-unaligned
+igt@gem_reloc_overflow@batch-both-unaligned-noprefault
+igt@gem_reloc_overflow@batch-end-unaligned
+igt@gem_reloc_overflow@batch-end-unaligned-noprefault
+igt@gem_reloc_overflow@batch-start-unaligned
+igt@gem_reloc_overflow@batch-start-unaligned-noprefault
+igt@gem_reloc_overflow@buffercount-overflow
+igt@gem_reloc_overflow@invalid-address
+igt@gem_reloc_overflow@invalid-address-noprefault
+igt@gem_reloc_overflow@single-fault
+igt@gem_reloc_overflow@single-fault-noprefault
+igt@gem_reloc_overflow@source-offset-big-reloc-cpu
+igt@gem_reloc_overflow@source-offset-big-reloc-gtt
+igt@gem_reloc_overflow@source-offset-end-gen8-reloc-cpu
+igt@gem_reloc_overflow@source-offset-end-gen8-reloc-gtt
+igt@gem_reloc_overflow@source-offset-negative-reloc-cpu
+igt@gem_reloc_overflow@source-offset-negative-reloc-gtt
+igt@gem_reloc_overflow@source-offset-overflow-gen8-reloc-cpu
+igt@gem_reloc_overflow@source-offset-overflow-gen8-reloc-gtt
+igt@gem_reloc_overflow@source-offset-page-stradle-gen8-reloc-cpu
+igt@gem_reloc_overflow@source-offset-page-stradle-gen8-reloc-gtt
+igt@gem_reloc_overflow@source-offset-unaligned-reloc-cpu
+igt@gem_reloc_overflow@source-offset-unaligned-reloc-gtt
+igt@gem_reloc_vs_gpu@faulting-reloc
+igt@gem_reloc_vs_gpu@faulting-reloc-interruptible
+igt@gem_reloc_vs_gpu@forked-faulting-reloc
+igt@gem_reloc_vs_gpu@interruptible
+igt@gem_reloc_vs_gpu@normal
+igt@gem_render_copy
+igt@gem_render_copy_redux@flink
+igt@gem_render_copy_redux@flink-interruptible
+igt@gem_render_copy_redux@interruptible
+igt@gem_render_copy_redux@normal
+igt@gem_render_linear_blits@basic
+igt@gem_render_tiled_blits@basic
+igt@gem_ringfill@basic-default
+igt@gem_ringfill@basic-default-forked
+igt@gem_ringfill@basic-default-hang
+igt@gem_ringfill@basic-default-interruptible
+igt@gem_ringfill@blt
+igt@gem_ringfill@bsd
+igt@gem_ringfill@bsd1
+igt@gem_ringfill@bsd2
+igt@gem_ringfill@render
+igt@gem_ringfill@vebox
+igt@gem_ring_sync_copy@sync-blitter-render-read-write
+igt@gem_ring_sync_copy@sync-blitter-render-write-read
+igt@gem_ring_sync_copy@sync-blitter-render-write-write
+igt@gem_ring_sync_copy@sync-render-blitter-read-write
+igt@gem_ring_sync_copy@sync-render-blitter-write-read
+igt@gem_ring_sync_copy@sync-render-blitter-write-write
+igt@gem_set_tiling_vs_blt@tiled-to-tiled
+igt@gem_set_tiling_vs_blt@tiled-to-untiled
+igt@gem_set_tiling_vs_blt@untiled-to-tiled
+igt@gem_set_tiling_vs_gtt
+igt@gem_set_tiling_vs_pwrite
+igt@gem_storedw_loop@basic-blt
+igt@gem_storedw_loop@basic-bsd
+igt@gem_storedw_loop@basic-bsd1
+igt@gem_storedw_loop@basic-bsd2
+igt@gem_storedw_loop@basic-default
+igt@gem_storedw_loop@basic-render
+igt@gem_storedw_loop@basic-vebox
+igt@gem_storedw_loop@long-blt
+igt@gem_storedw_loop@long-bsd
+igt@gem_storedw_loop@long-bsd1
+igt@gem_storedw_loop@long-bsd2
+igt@gem_storedw_loop@long-vebox
+igt@gem_sync@basic-all
+igt@gem_sync@basic-each
+igt@gem_sync@basic-many-each
+igt@gem_sync@basic-store-all
+igt@gem_sync@basic-store-each
+igt@gem_threaded_access_tiled
+igt@gem_tiled_blits@basic
+igt@gem_tiled_fence_blits@basic
+igt@gem_tiled_pread_basic
+igt@gem_tiling_max_stride
+igt@gem_unfence_active_buffers
+igt@gem_unref_active_buffers
+igt@gem_wait@invalid-buf
+igt@gem_wait@invalid-flags
+igt@gem_workarounds@basic-read
+igt@gvt_basic@invalid-placeholder-test
+igt@kms_addfb_basic@addfb25-bad-modifier
+igt@kms_addfb_basic@addfb25-framebuffer-vs-set-tiling
+igt@kms_addfb_basic@addfb25-modifier-no-flag
+igt@kms_addfb_basic@addfb25-x-tiled
+igt@kms_addfb_basic@addfb25-x-tiled-mismatch
+igt@kms_addfb_basic@addfb25-yf-tiled
+igt@kms_addfb_basic@addfb25-y-tiled
+igt@kms_addfb_basic@addfb25-y-tiled-small
+igt@kms_addfb_basic@bad-pitch-0
+igt@kms_addfb_basic@bad-pitch-1024
+igt@kms_addfb_basic@bad-pitch-128
+igt@kms_addfb_basic@bad-pitch-256
+igt@kms_addfb_basic@bad-pitch-32
+igt@kms_addfb_basic@bad-pitch-63
+igt@kms_addfb_basic@bad-pitch-65536
+igt@kms_addfb_basic@bad-pitch-999
+igt@kms_addfb_basic@basic
+igt@kms_addfb_basic@basic-x-tiled
+igt@kms_addfb_basic@basic-y-tiled
+igt@kms_addfb_basic@bo-too-small
+igt@kms_addfb_basic@bo-too-small-due-to-tiling
+igt@kms_addfb_basic@clobberred-modifier
+igt@kms_addfb_basic@framebuffer-vs-set-tiling
+igt@kms_addfb_basic@invalid-get-prop
+igt@kms_addfb_basic@invalid-get-prop-any
+igt@kms_addfb_basic@invalid-set-prop
+igt@kms_addfb_basic@invalid-set-prop-any
+igt@kms_addfb_basic@no-handle
+igt@kms_addfb_basic@size-max
+igt@kms_addfb_basic@small-bo
+igt@kms_addfb_basic@tile-pitch-mismatch
+igt@kms_addfb_basic@too-high
+igt@kms_addfb_basic@too-wide
+igt@kms_addfb_basic@unused-handle
+igt@kms_addfb_basic@unused-modifier
+igt@kms_addfb_basic@unused-offsets
+igt@kms_addfb_basic@unused-pitches
+igt@kms_busy@basic-flip-default-a
+igt@kms_busy@basic-flip-default-b
+igt@kms_busy@basic-flip-default-c
+igt@kms_cursor_legacy@basic-flip-after-cursor-atomic
+igt@kms_cursor_legacy@basic-flip-after-cursor-legacy
+igt@kms_cursor_legacy@basic-flip-after-cursor-varying-size
+igt@kms_cursor_legacy@basic-flip-before-cursor-atomic
+igt@kms_cursor_legacy@basic-flip-before-cursor-legacy
+igt@kms_cursor_legacy@basic-flip-before-cursor-varying-size
+igt@kms_flip@basic-flip-vs-dpms
+igt@kms_flip@basic-flip-vs-modeset
+igt@kms_flip@basic-flip-vs-wf_vblank
+igt@kms_flip@basic-plain-flip
+igt@kms_force_connector_basic@force-connector-state
+igt@kms_force_connector_basic@force-edid
+igt@kms_force_connector_basic@force-load-detect
+igt@kms_force_connector_basic@prune-stale-modes
+igt@kms_frontbuffer_tracking@basic
+igt@kms_pipe_crc_basic@bad-nb-words-1
+igt@kms_pipe_crc_basic@bad-nb-words-3
+igt@kms_pipe_crc_basic@bad-pipe
+igt@kms_pipe_crc_basic@bad-source
+igt@kms_pipe_crc_basic@hang-read-crc-pipe-a
+igt@kms_pipe_crc_basic@hang-read-crc-pipe-b
+igt@kms_pipe_crc_basic@hang-read-crc-pipe-c
+igt@kms_pipe_crc_basic@nonblocking-crc-pipe-a
+igt@kms_pipe_crc_basic@nonblocking-crc-pipe-a-frame-sequence
+igt@kms_pipe_crc_basic@nonblocking-crc-pipe-b
+igt@kms_pipe_crc_basic@nonblocking-crc-pipe-b-frame-sequence
+igt@kms_pipe_crc_basic@nonblocking-crc-pipe-c
+igt@kms_pipe_crc_basic@nonblocking-crc-pipe-c-frame-sequence
+igt@kms_pipe_crc_basic@read-crc-pipe-a
+igt@kms_pipe_crc_basic@read-crc-pipe-a-frame-sequence
+igt@kms_pipe_crc_basic@read-crc-pipe-b
+igt@kms_pipe_crc_basic@read-crc-pipe-b-frame-sequence
+igt@kms_pipe_crc_basic@read-crc-pipe-c
+igt@kms_pipe_crc_basic@read-crc-pipe-c-frame-sequence
+igt@kms_pipe_crc_basic@suspend-read-crc-pipe-a
+igt@kms_pipe_crc_basic@suspend-read-crc-pipe-b
+igt@kms_pipe_crc_basic@suspend-read-crc-pipe-c
+igt@kms_pwrite_crc
+igt@kms_setmode@basic-clone-single-crtc
+igt@kms_sink_crc_basic
+igt@kms_sysfs_edid_timing
+igt@pm_backlight@basic-brightness
+igt@pm_rpm@basic-pci-d3-state
+igt@pm_rpm@basic-rte
+igt@pm_rps@basic-api
+igt@prime_busy@basic-after-default
+igt@prime_busy@basic-before-default
+igt@prime_busy@basic-wait-after-default
+igt@prime_busy@basic-wait-before-default
+igt@prime_self_import@basic-llseek-bad
+igt@prime_self_import@basic-llseek-size
+igt@prime_self_import@basic-with_fd_dup
+igt@prime_self_import@basic-with_one_bo
+igt@prime_self_import@basic-with_one_bo_two_files
+igt@prime_self_import@basic-with_two_bos
+igt@prime_vgem@basic-busy-default
+igt@prime_vgem@basic-fence-flip
+igt@prime_vgem@basic-fence-mmap
+igt@prime_vgem@basic-fence-read
+igt@prime_vgem@basic-fence-wait-default
+igt@prime_vgem@basic-gtt
+igt@prime_vgem@basic-read
+igt@prime_vgem@basic-sync-default
+igt@prime_vgem@basic-wait-default
+igt@prime_vgem@basic-write
+igt@test_rte_check
+igt@tools_test
+igt@vgem_basic@create
+igt@vgem_basic@debugfs
+igt@vgem_basic@dmabuf-export
+igt@vgem_basic@dmabuf-fence
+igt@vgem_basic@dmabuf-fence-before
+igt@vgem_basic@dmabuf-mmap
+igt@vgem_basic@mmap
+igt@vgem_basic@second-client
+igt@vgem_basic@sysfs
+igt@vgem_basic@unload
+igt@vgem_reload_basic